module("luci.controller.admin.vzanty",package.seeall)
function index()
if not nixio.fs.access("/etc/config/vzant")then return end
if nixio.fs.access("/etc/config/vzant_show")then
entry({"admin","status"},alias("admin","status","vzant"),_("Status"),0).index=true
entry({"admin","status","vzant"},template("themes/vzant/vzant"),_("Vzant"),0)
else
entry({"admin","status"},alias("admin","status","overview"),_("Status"),20).index=true
entry({"admin","status","vzant"},template("themes/vzant/vzant"),_("Vzant"),60)
end
entry({"admin","status","vzant","show"},call("show_menu")).leaf=true
entry({"admin","status","vzant","hide"},call("hide_menu")).leaf=true
entry({'admin','status','vzant','addfavourite'},call('addfavourite'))
entry({'admin','status','vzant','delfavourite'},call('delfavourite'))
entry({'admin','status','vzant','getfavourites'},call('getfavourites'))
end
function show_menu()
luci.sys.call("touch /etc/config/vzant_show")
luci.http.redirect(luci.dispatcher.build_url("admin","status","vzant"))
end
function hide_menu()
luci.sys.call("rm -rf /etc/config/vzant_show")
luci.http.redirect(luci.dispatcher.build_url("admin","status","overview"))
end
function addfavourite()
local o=string.gsub(luci.http.formvalue("title"),"%s+","")
local t=luci.http.formvalue("src")
local e=os.time()
local a="uci set vzant."..e.."=favourite"
luci.sys.exec(a)
local a="uci set vzant."..e..".title="..o
luci.sys.exec(a)
local t="uci set vzant."..e..".src="..t
luci.sys.exec(t)
luci.sys.exec("uci commit vzant");
local t={}
t['data']="ok"
t['msg']=e
luci.http.prepare_content("application/json")
luci.http.write_json(t)
end
function getfavourites()
local e=luci.model.uci.cursor()
local a={}
e:foreach(
'vzant',
'favourite',
function(t)
local e={}
e['name']=t['.name']
e['title']=t.title
e['src']=t.src
table.insert(a,e)
end
)
luci.http.prepare_content('application/json')
luci.http.write_json(a)
end
function delfavourite()
local e=luci.http.formvalue("name")
local e="uci delete vzant."..e
luci.sys.exec(e)
luci.sys.exec("uci commit vzant");
local e={}
e['data']="ok"
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
